jQuery(document).ready(function ($) {

	// Trigger the publish action.
	jQuery('.mainwp-post-plus-publish-action').on('click', function () {
		if (!confirm("Are you sure?")) {
			return false;
		}
		mainwp_pplus_draft_publish_start_specific(jQuery(this), false)
		return false;
	});

	// Trigger the delete action.
	jQuery('.mainwp-post-plus-delete-action').on('click', function () {
		if (!confirm("Are you sure?")) {
			return false;
		}
		mainwp_pplus_draft_delete_start_specific(jQuery(this), false)
		return false;
	});

	// Trigger the bulk actions.
	jQuery('#mainwp-post-plus-bulk-actions-button').on('click', function () {
		if (!confirm("Are you sure?")) {
			return false;
		}
		var bulk_act = jQuery('#mainwp-post-plus-bulk-actions').val();
		mainwp_pplus_draft_do_bulk_action(bulk_act);
	});

	// Check all checkboxes.
	jQuery('#mainwp-post-plus-drafts-table th input[type="checkbox"]').change(function () {
		var checkboxes = jQuery('#mainwp-post-plus-drafts-table').find(':checkbox');
		if (jQuery(this).prop('checked')) {
			checkboxes.prop('checked', true);
		} else {
			checkboxes.prop('checked', false);
		}
	});

	// Check all options in the metabox.
	jQuery('#pplus_meta_privelege_check_all').on('click', function () {
		var chk = $(this).is(':checked') ? true : false;
		jQuery('.pplus_meta_privelege_group').find('input[type=checkbox]').each(function () {
			jQuery(this).prop('checked', chk);
			if (!chk) {
				jQuery(this).attr('disabled', true);
			} else {
				jQuery(this).attr('disabled', false);
			}
		});
	});
});

// Set defaults.
var pplus_bulkMaxThreads = 3;
var pplus_bulkTotalThreads = 0;
var pplus_bulkCurrentThreads = 0;
var pplus_bulkFinishedThreads = 0;
var pplus_bulkFinishedClone = 0;
var pplus_bulkTotalClone = 0;

// Init bulk actions.
mainwp_pplus_bulk_action_init = function () {
	pplus_bulkTotalThreads = 0;
	pplus_bulkCurrentThreads = 0;
	pplus_bulkFinishedThreads = 0;
}

// Trigger bulk actions
mainwp_pplus_draft_do_bulk_action = function (act) {
	mainwp_pplus_bulk_action_init();
	var selector = 'td input[type="checkbox"]:checked';
	jQuery(selector).addClass('queue');
	switch (act) {
		case 'publish-selected':
			mainwp_pplus_draft_publish_start_next(selector);
			break;
		case 'delete-selected':
			if (!confirm("Are you sure?")) {
				return false;
			}
			mainwp_pplus_draft_delete_start_next(selector);
			break;
		case 'preview-selected':
			mainwp_pplus_draft_preview_open(selector);
			break;
	}
}

// Loop through drafts to publish
mainwp_pplus_draft_publish_start_next = function (selector) {
	while ((objProcess = jQuery(selector + '.queue:first')) && (objProcess.length > 0) && (pplus_bulkCurrentThreads < pplus_bulkMaxThreads)) {
		objProcess.removeClass('queue');
		mainwp_pplus_draft_publish_start_specific(objProcess, true, selector);
	}
}

// Publish drafts
mainwp_pplus_draft_publish_start_specific = function (pObj, bulk, selector) {
	var row = pObj.closest('tr');
	var data = mainwp_secure_data({
		action: 'mainwp_pplus_publish_post',
		postId: row.attr('post-id')
	});

	if (bulk) {
		pplus_bulkCurrentThreads++;
	}

	row.html('<td colspan="999"><i class="notched circle loading icon"></i> ' + __('Publishing. Please wait...') + '</td>');

	jQuery.post(ajaxurl, data, function (response) {
		if (response) {
			if (response['result']) {
				if (response['failed_posts'] && response['failed_posts'] > 0) {
					row.html('<td colspan="999"><i class="red times icon"></i> ' + response['result'] + '</td>');
				} else {
					row.html('<td colspan="999">' + response['result'] + '</td>');
				}
			} else if (response['error']) {
				row.html('<td colspan="999"><i class="red times icon"></i> ' + response['error'] + '</td>');
			} else {
				row.html('<td colspan="999"><i class="red times icon"></i> ' + __('Undefined error occurred. Please, try again.') + '</td>');
			}
		} else {
			row.html('<td colspan="999"><i class="red times icon"></i> ' + __('Undefined error occurred. Please, try again.') + '</td>');
		}

		if (bulk) {
			pplus_bulkCurrentThreads--;
			pplus_bulkFinishedThreads++;
			mainwp_pplus_draft_publish_start_next(selector);
		}
	}, 'json');
	return false;
}

// Loop drafts to delete
mainwp_pplus_draft_delete_start_next = function (selector) {
	while ((objProcess = jQuery(selector + '.queue:first')) && (objProcess.length > 0) && (pplus_bulkCurrentThreads < pplus_bulkMaxThreads)) {
		objProcess.removeClass('queue');
		mainwp_pplus_draft_delete_start_specific(objProcess, true, selector);
	}
}

// Delete drafts
mainwp_pplus_draft_delete_start_specific = function (pObj, bulk, selector) {
	var row = pObj.closest('tr');
	var data = mainwp_secure_data({
		action: 'mainwp_pplus_delete_post',
		postId: row.attr('post-id')
	});

	if (bulk) {
		pplus_bulkCurrentThreads++;
	}

	row.html('<td colspan="999"><i class="notched circle loading icon"></i> ' + __('Deleting. Please wait...') + '</td>');

	jQuery.post(ajaxurl, data, function (response) {
		if (response == 'success') {
			row.fadeOut();
		} else {
			row.html('<td colspan="999"><i class="red times icon"></i> ' + __('Undefined error occurred. Please, try again.') + '</td>');
		}

		if (bulk) {
			pplus_bulkCurrentThreads--;
			pplus_bulkFinishedThreads++;
			mainwp_pplus_draft_delete_start_next(selector);
		}
	});
	return false;
}

// Open preview
mainwp_pplus_draft_preview_open = function (selector) {
	while ((objProcess = jQuery(selector + '.queue:first')) && (objProcess.length > 0)) {
		objProcess.removeClass('queue');
		var row = objProcess.closest('tr');
		var link = row.find('.mainwp-post-plus-preview-action').attr('href');
		window.open(link, '_blank');
	}
}


jQuery(document).on('click', '.post_getclone', function () {
	mainwp_pplus_postAction(jQuery(this), 'post');
	return false;
});
jQuery(document).on('click', '.page_getclone', function () {
	mainwp_pplus_postAction(jQuery(this), 'page');
	return false;
});

mainwp_pplus_popup_init = function (pBulk, pType) {
	var data = {};
	data.callback = function () {
		bulkTaskRunning = false;
		window.location.href = location.href;
	};
	data.statusText = __('cloned');
	if (pBulk) {
		jQuery('#postplus-manageposts-modal').attr('action-bulk', 'yes');
	} else {
		jQuery('#postplus-manageposts-modal').attr('action-bulk', 'no');
	}
	mainwpPopup('#postplus-manageposts-modal').init(data);
}

mainwp_pplus_postAction = function (elem, postType) {
	var rowElement = jQuery(elem).parents('tr');
	var postId = rowElement.find('.postId').val();
	var websiteId = rowElement.find('.websiteId').val();

	if (postType === 'page') {
		postId = rowElement.find('.pageId').val();
	}

	var data = mainwp_secure_data({
		action: 'mainwp_post_plus_get_clone',
		postId: postId,
		websiteId: websiteId,
		replace_advance_img: 1,
		security: jQuery('#post_plus_clone_nonce').val()
	});

	if (typeof postType !== "undefined") {
		data['postType'] = postType;
	}

	rowElement.html('<td colspan="99"><i class="notched circle loading icon"></i> Please wait...</td>');
	jQuery.post(ajaxurl, data, function (response) {
		if (response.error) {
			rowElement.html('<td colspan="99"><i class="times circle red icon"></i>' + response.error + '</td>');
		} else if (response.result) {
			rowElement.html('<td colspan="99"><i class="check circle green icon"></i> ' + response.result + '</td>');
		} else {
			rowElement.hide();
			if (response.id) {
				mainwp_pplus_popup_init(false, postType);
				jQuery('#content_clone_posts_short_detail').show();
				jQuery('#post_clone_title').html(response.title);
				jQuery('#post_clone_content').html(response.content);
				jQuery('#post_clone_date').html(response.date);
				jQuery('#post_clone_posttype').html(response.posttype);
				jQuery('#post_clone_status').html(response.status);
				jQuery('#post_clone_id').val(response.id);
			}
		}
	}, 'json');

	return false;
};


jQuery(document).on('click', '#postplus-publishing-button', function () {
	var bulkAct = jQuery('#postplus-manageposts-modal').attr('action-bulk');
	mainwp_pplus_perform_clone(bulkAct);
	return false;
});

mainwp_pplus_perform_clone = function (bulkAct) {
	var pBulk = ('no' == bulkAct) ? false : true;
	var sites_ids = '';
	var groups_ids = '';

	var tab = jQuery('#postplus-manageposts-modal #select_sites_tab').val();
	var sites = [];
	var groups = [];
	if (tab == 'site') {
		sites = jQuery.map(jQuery('#postplus-manageposts-modal #mainwp-select-sites-list INPUT:checkbox:checked'), function (el) {
			return jQuery(el).val();
		});
	} else if (tab == 'staging') {
		sites = jQuery.map(jQuery('#postplus-manageposts-modal #mainwp-select-staging-sites-list INPUT:checkbox:checked'), function (el) {
			return jQuery(el).val();
		});
	} else { //group
		groups = jQuery.map(jQuery('#postplus-manageposts-modal #mainwp-select-groups-list INPUT:checkbox:checked'), function (el) {
			return jQuery(el).val();
		});
	}

	if (sites.length == 0 && 0 == groups.length) {
		feedback('postplus-manageposts-modal #mainwp-message-zone', __('Please select at least one website.'), 'yellow');
		return false;
	} else {
		jQuery('#postplus-manageposts-modal #mainwp-message-zone').fadeOut(500);
		if (pBulk) {
			mainwp_pplus_perform_bulk_clone_prepare(sites, groups);
		} else {
			var sites_ids = sites.join("-");
			var groups_ids = groups.join("-");
			location.href = 'admin.php?page=Extensions-Mainwp-Post-Plus-Extension&postplus_nonce=' + jQuery('#post_plus_clone_nonce').val() + '&id=' + jQuery('#post_clone_id').val() + '&selected_sites=' + sites_ids + '&selected_groups=' + groups_ids;
		}
	}
}

jQuery(document).on('click', '#mainwp-do-pages-bulk-actions', function () {
	mainwp_pplus_bulkpostAction('page');
});

jQuery(document).on('click', '#mainwp-do-posts-bulk-actions', function () {
	mainwp_pplus_bulkpostAction('post');
});

mainwp_pplus_bulkpostAction = function (pType) {

	var action = jQuery('#mainwp-bulk-actions').val();

	if (action != 'get_clone')
		return false;

	var tmp_list = [];

	if ('post' == pType) {
		jQuery("input[name='post[]']:checked").each(
			function (index, elem) {
				var rowElement = jQuery(elem).parents('tr');
				if (!rowElement.find('.column-status').hasClass('post-trash')) {
					tmp_list.push(elem);
				}
			}
		);
	} else {
		jQuery("input[name='page[]']:checked").each(
			function (index, elem) {
				var rowElement = jQuery(elem).parents('tr');
				if (!rowElement.find('.column-status').hasClass('post-trash')) {
					tmp_list.push(elem);
				}
			}
		);
	}

	if (tmp_list.length == 0)
		return false;

	if ('post' == pType) {
		jQuery('#mainwp-do-posts-bulk-actions').attr('disabled', 'true');
	} else {
		jQuery('#mainwp-do-pages-bulk-actions').attr('disabled', 'true');
	}

	mainwp_pplus_popup_init(true, pType);

	jQuery('#content_clone_posts_short_list').show();

	jQuery(tmp_list).each(
		function (index, elem) {
			var rowElement = jQuery(elem).parents('tr');
			var postId = rowElement.find('.postId').val();
			if (pType == 'page') {
				postId = rowElement.find('.pageId').val();
			}
			var websiteId = rowElement.find('.websiteId').val();
			jQuery('#content_clone_posts_short_list').append('<div class="post-item-processing queue queue-second" dashboard-post-clone-id="0" child-post-id="' + postId + '" website-id="' + websiteId + '"><div class="clone-result"></div><div class="post-progress"><i class="clock outline icon"></i> Queued</div></div>');
		}
	);

	mainwp_pplus_bulk_action_init();
	jQuery('#postplus-publishing-button').attr('disabled', true);
	pplus_bulkTotalThreads = jQuery('.post-item-processing.queue').length;
	mainwp_pplus_bulkpostAction_start_next(pType);
	return false;
}

mainwp_pplus_bulkpostAction_start_next = function (pType) {
	while ((objPost = jQuery('.post-item-processing.queue:first')) && (objPost.length > 0) && (pplus_bulkCurrentThreads < pplus_bulkMaxThreads)) {
		objPost.removeClass('queue');
		mainwp_pplus_bulkpostAction_start_specific(objPost, pType);
	}
}

mainwp_pplus_bulkpostAction_start_specific = function (objPost, pType) {
	pplus_bulkCurrentThreads++;
	var postId = jQuery(objPost).attr('child-post-id');
	var websiteId = jQuery(objPost).attr('website-id');

	var data = mainwp_secure_data({
		action: 'mainwp_post_plus_get_bulk_clone',
		postId: postId,
		websiteId: websiteId,
		security: jQuery('#post_plus_clone_nonce').val(),
		postType: ('post' == pType) ? 'bulkpost' : 'bulkpage',
		replace_advance_img: 1
	});

	jQuery('#postplus-manageposts-modal #mainwp-select-sites-list #selected_sites_' + websiteId).prop("disabled", true);

	jQuery(objPost).find('.post-progress').html('<i class="notched circle loading icon"></i> Please wait...');
	jQuery.post(ajaxurl, data, function (response) {
		jQuery(objPost).find('.post-progress').html('');
		if (response.error) {
			jQuery(objPost).find('.post-progress').html('<i class="times circle red icon"></i>' + response.error);
		} else if (response.result) {
			jQuery(objPost).find('.post-progress').html('<i class="check circle green icon"></i> ' + response.result);
		} else {
			jQuery(objPost).find('.clone-result').html(jQuery('#content_clone_posts_short_temp').html());
			if (response.id) {
				jQuery(objPost).find('.post_bulk_clone_title').html(response.title);
				jQuery(objPost).find('.post_bulk_clone_date').html(response.date);
				jQuery(objPost).find('.post_bulk_clone_posttype').html(response.posttype);
				jQuery(objPost).find('.post_bulk_clone_status').html(response.status);
				jQuery(objPost).attr('dashboard-post-clone-id', response.id);
				if (response.postplus_warning) {
					jQuery(objPost).find('.post_bulk_clone_message').html('<div class="ui message red">' + response.postplus_warning + '</div>').show();
				}
			}
		}
		pplus_bulkCurrentThreads--;
		pplus_bulkFinishedThreads++;
		if (pplus_bulkTotalThreads == pplus_bulkFinishedThreads) {
			jQuery('#postplus-publishing-button').attr('disabled', false);
		}
		mainwp_pplus_bulkpostAction_start_next(pType);
	}, 'json');

	return false;
};

mainwp_pplus_perform_bulk_clone_prepare = function (sites, groups) {
	var data = mainwp_secure_data({
		action: 'mainwp_post_plus_preparing_bulk_clone',
		sites: sites,
		groups: groups,
		security: jQuery('#post_plus_clone_nonce').val(),
	});
	jQuery('#postplus-publishing-button').attr('disabled', true);
	jQuery('#postplus-manageposts-modal .popup-side-right').html('<i class="notched circle loading icon"></i> Loading...').show();
	jQuery.post(ajaxurl, data, function (response) {
		jQuery('#postplus-manageposts-modal .popup-side-right').html(response);
		jQuery('#postplus-manageposts-modal .popup-side-right').hide();
		if (jQuery('.site-item-processing').length > 0) {
			pplus_bulkCurrentThreads = 0;
			pplus_bulkFinishedThreads = 0;
			pplus_bulkTotalThreads = jQuery('.site-item-processing').length;
			pplus_bulkTotalClone = pplus_bulkTotalThreads * jQuery('.post-item-processing.queue-second').length;
			jQuery('#postplus-manageposts-modal .mainwp-pplus-modal-progress').progress({ value: 0, total: pplus_bulkTotalClone });
			jQuery('#postplus-manageposts-modal .mainwp-pplus-modal-progress').show();
			jQuery('#postplus-manageposts-modal .mainwp-pplus-modal-progress').find('.label').html('0/' + pplus_bulkTotalClone + ' cloned');
			jQuery('#postplus-manageposts-modal .modal-left-content').css('border-right', '0px');
			mainwp_pplus_perform_clone_post_processing_start_next();
		}
	});
	return false;
}


mainwp_pplus_perform_clone_post_processing_start_next = function () {
	if ((objPost = jQuery('.post-item-processing.queue-second:first')) && (objPost.length > 0)) {
		objPost.removeClass('queue-second');
		var postId = jQuery(objPost).attr('dashboard-post-clone-id');
		mainwp_pplus_perform_clone_site_processing_start_next(postId); // start clone the postId to sites.
	}
}

mainwp_pplus_perform_clone_site_processing_start_next = function (postId) {
	while ((objSite = jQuery('#sites-bulk-clone .site-item-processing.queue:first')) && (objSite.length > 0) && (pplus_bulkCurrentThreads < pplus_bulkMaxThreads)) {
		objSite.removeClass('queue');
		jQuery('.post-item-processing[dashboard-post-clone-id="' + postId + '"] .post-clone-item').html('');
		jQuery('.post-item-processing[dashboard-post-clone-id="' + postId + '"] .post-progress').html('<i class="notched circle loading icon"></i>');
		mainwp_pplus_perform_clone_site_processing_start_specific(objSite, postId);
	}
}

mainwp_pplus_perform_clone_site_processing_start_specific = function (objSite, postId) {
	pplus_bulkCurrentThreads++;
	var websiteId = jQuery(objSite).attr('website-id');
	var data = mainwp_secure_data({
		action: 'mainwp_post_plus_posting_bulk_clone',
		post_id: postId,
		site_id: websiteId,
		security: jQuery('#post_plus_clone_nonce').val()
	});

	var postItemProcessing = jQuery('.post-item-processing[dashboard-post-clone-id="' + postId + '"]');
	// postItemProcessing.find('.post-progress').html('<i class="notched circle loading icon"></i>');
	// jQuery(objSite).find('.site-progress').html('<i class="notched circle loading icon"></i>');
	jQuery.post(ajaxurl, data, function (response) {
		pplus_bulkCurrentThreads--;
		pplus_bulkFinishedThreads++;
		pplus_bulkFinishedClone++
		jQuery('#postplus-manageposts-modal .mainwp-pplus-modal-progress').progress('set progress', pplus_bulkFinishedClone);
		jQuery('#postplus-manageposts-modal .mainwp-pplus-modal-progress').find('.label').html(pplus_bulkFinishedClone + '/' + pplus_bulkTotalClone + ' cloned');
		// jQuery(objSite).find('.site-progress').html('');
		if (response && response.result) {
			var clone_result = '<div class="item"><a href="admin.php?page=managesites&dashboard=' + websiteId + '">' + jQuery(objSite).attr('website-name') + '</a>: ';
			clone_result += response.result;
			if (response.edit_link !== '') {
				clone_result += response.edit_link;
			}
			clone_result += '</div>';
			postItemProcessing.find('.clone-result').append(clone_result);
		}

		// if cloned the postId to all the sites.
		if (pplus_bulkFinishedThreads == pplus_bulkTotalThreads) {
			postItemProcessing.find('.post-progress').html('');
			pplus_bulkFinishedThreads = 0; // to reset.
			if (jQuery('.post-item-processing.queue-second').length > 0) {
				jQuery('#sites-bulk-clone .site-item-processing').each(function () {
					jQuery(this).addClass('queue');
					//jQuery(this).find('.site-progress').html('');
				});; // reset sites queue.
				mainwp_pplus_perform_clone_post_processing_start_next(); // to clone next post.
			}
			// clone finished for the postId.
			var data = mainwp_secure_data({
				action: 'mainwp_post_plus_bulk_clone_delete',
				post_id: postId,
				security: jQuery('#post_plus_clone_nonce').val()
			});
			jQuery.post(ajaxurl, data, function (response) {

			});
		} else {
			mainwp_pplus_perform_clone_site_processing_start_next(postId); // to clone the postId to next site.
		}
	}, 'json');

	return false;
};
